local f = CreateFrame("Frame")
local healers = {}
local dispeller = ""
local bestTime = 0
local enabled = false
slaves = {}
local player = UnitName("player")
local ticks = 0
debuffed = false
local master = "Grontil"
f:RegisterEvent("ENCOUNTER_START")
f:RegisterEvent("CHAT_MSG_ADDON")
f:RegisterEvent("UNIT_AURA")
RegisterAddonMessagePrefix("EnRT_DI")
f:SetScript("OnUpdate",function(self, elapsed)
	if debuffed then
		ticks = ticks + elapsed
		if ticks > 0.8 then
			print("checking")
			for i = 1, GetNumGroupMembers() do
				local raider = "raid"..i
				if UnitIsVisible(raider) and UnitName(raider) ~= player then
					if IsItemInRange(63427, raider) then
						SendAddonMessage("EnRT_DI", "false", "WHISPER", master)
						break
					end
					SendAddonMessage("EnRT_DI", "true", "WHISPER", master)
				end
			end
			ticks = 0
		end
	end
end)
f:SetScript("OnEvent", function(self, event, ...)
	if event == "ENCOUNTER_START" then
		local eID = ...
		if eID == 2048 then
			enabled = true
			master = EnRT_GetRaidLeader()
		end
	elseif event == "CHAT_MSG_ADDON" then
		local prefix, msg, channel, sender = ...
		sender = Ambiguate(sender, "short")
		print(msg)
		if prefix == "EnRT_DI" and player == master then
			if msg == "true" then
				SetRaidTarget(sender, EnRT_Contains(slaves, sender))
			else
				SetRaidTarget(sender, 0)
			end
		end
	elseif event == "UNIT_AURA" then
		if player == master then
			local unit = ...
			local unitName = UnitName(unit)
			if UnitBuff(unit, GetSpellInfo(201695)) then --Ecohing Anguish
				if not EnRT_Contains(slaves, unitName) then
					slaves[#slaves+1] = unitName
				end
			else
				if EnRT_Contains(slaves, unitName) then
					SetRaidTarget(unitName, 0)
					slaves[EnRT_Contains(slaves, unitName)] = nil
				end
			end
		end
		if UnitBuff(player, GetSpellInfo(201695)) then
			debuffed = true
		else
			debuffed = false
		end
	end
end)
--[[
	Checking if a table PGF_Contains a given value and if it does, what index is the value located at
	param(arr) table
	param(value) T - value to check exists
	return boolean or integer / returns false if the table does not contain the value otherwise it returns the index of where the value is locatedd
]]
function EnRT_Contains(arr, value)
	if value == nil then
		return false
	end
	if arr == nil then
		return false
	end
	for k, v in pairs(arr) do
		if v == value then
			return k
		end
	end
	return false
end
function EnRT_GetRaidLeader()
	for i = 1, GetNumGroupMembers() do
		local raider = "raid"..i
		if select(2, GetRaidRosterInfo(raider)) == 2 then
			return UnitName(raider)
		end
	end
	return ""
end
